!----------------------------------------------------------------------------------------
!	test for precession,  ge nieuwenhuys, Oktober 25, 2005
!----------------------------------------------------------------------------------------
!
!	The initial muon direction is given by the unit vector emu, the magnetic field
!	is b (vector) and the observer (positroncounter) is supposed to be in the 
!	direction of the unit-vector observer.
!
	USE DFLIB
!
	real*8    b(3), eb(3), emu(3), gyro(3), azi(3), length_b, length_gyro, length_azi
	real*8    observer(3), amplitude, help(3), cos_phase, phase
	real*8    length, saclar_pruduct, length_vector_product

1	write(6,2)
2	format('  Give initial muon  > '\)
	read(5,*,err=1) emu
	emu = emu / length(emu)
3	write(6,4)
4	format('  Give field         > '\)
	read(5,*,err=3) b
	length_b = length( b )
	IF ( length_b .LT. 0.001 ) GOTO 1
5	write(6,6)
6	format('  Give observer      > '\)
	read(5,*,err=5) observer
	IF ( length(observer) .LT. 0.01 ) GOTO 3
	observer = observer / length( observer) 
!  
	eb			= b / length_b							! unit vector along b
	length_azi  = scalar_product( emu, eb )				! length of azimuth of cone
	azi			= length_azi * eb						! vector with length parallel to field
	length_gyro = length_vector_product( emu, eb )		! length of the radius of base circle
	gyro		= emu - azi								! that radius as vector at t = 0
	amplitude   = length_vector_product( observer, eb )	! the projection of the radius on the
!														  direction of the observer.
!
!	Spin will rotate around the field, and start -of course- from the initial spin direction.
!	So the radial vector at t=0 equals emu - azi, while the amplitude is the length
!	of the vector product observer, field. That means that the cosine of the phase angle 
!	is the projection of gyro on the observer direction divided by the amplitude. 
!
	IF ( abs( amplitude ) .GT. 1D-09 ) THEN
	   cos_phase   = scalar_product( gyro, observer ) / amplitude
	   ELSE
	   cos_phase = 1.0
	   END IF
!
	phase       = acos( cos_phase )
!
	write(6,'(a,3f10.5)') ' emu        = ', emu
	write(6,'(a,3f10.5)') ' eb         = ', eb
	write(6,'(a,1f10.5)') ' length_azi = ', length_azi
	write(6,'(a,3f10.5)') ' azi        = ', azi
	write(6,'(a,1f10.5)') ' length_gyro= ', length_gyro
	write(6,'(a,3f10.5)') ' gyro       = ', gyro
	write(6,'(a,1f10.5)') ' amplitude  = ', amplitude
	write(6,'(a,1f10.5)') ' cos_phase  = ', cos_phase
	write(6,'(a,1f10.5)') ' phase      = ', phase
	write(6,*) ' '
!
	GOTO 5
!
	END
!
	real*8 FUNCTION length( v )
	real*8 v(3)
	length = sqrt( sum( v * v ) )
	RETURN
	END
!
	real*8 FUNCTION scalar_product( v, w )
	real*8 v(3), w(3)
	scalar_product = sum( v * w )
	RETURN
	END
!
	real*8 FUNCTION length_vector_product( v, w )
	real*8 v(3), w(3), vp(3), length
	call vector_product( vp, v, w )
	length_vector_product = length( vp )
	RETURN
	END
!
	SUBROUTINE vector_product( vp, v, w )
	real*8 v(3), w(3), vp(3)
	vp(1) = v(2) * w(3) - v(3) * w(2)
	vp(2) = v(3) * w(1) - v(1) * w(3)
	vp(3) = v(1) * w(2) - v(2) * w(1)
	RETURN
	END